import { openBlock as l, createElementBlock as n, createElementVNode as s, toDisplayString as p, renderSlot as r, ref as w, computed as b, normalizeClass as y, unref as u, createVNode as L, withCtx as m, resolveComponent as C, createBlock as k, inject as A, withDirectives as V, isRef as B, vModelDynamic as N, createCommentVNode as v, provide as M, Fragment as x, renderList as D, vModelSelect as O, vModelText as K, useSlots as j, watch as E, normalizeStyle as Z, createTextVNode as F, onMounted as I, withModifiers as z, vModelCheckbox as G } from "vue";
const R = { class: "cf-action-card" }, H = { class: "cf-action-card__body" }, X = { class: "cf-action-card__title" }, J = { class: "cf-action-card__body__slot" }, Q = { class: "cf-action-card__action" }, Qt = {
  __name: "ActionCard",
  props: {
    title: String
  },
  setup(a) {
    const e = a;
    return (t, o) => (l(), n("div", R, [
      s("div", H, [
        s("div", X, p(e.title), 1),
        s("div", J, [
          r(t.$slots, "body")
        ])
      ]),
      s("div", Q, [
        r(t.$slots, "action")
      ])
    ]));
  }
};
const T = (a, e) => {
  const t = a.__vccOpts || a;
  for (const [o, i] of e)
    t[o] = i;
  return t;
}, W = {}, Y = { class: "cf-app-bar" };
function ee(a, e) {
  return l(), n("header", Y, [
    s("div", null, [
      r(a.$slots, "left")
    ]),
    s("div", null, [
      r(a.$slots, "right")
    ])
  ]);
}
const te = /* @__PURE__ */ T(W, [["render", ee]]);
const se = { class: "cf-dropdown-body" }, le = {
  __name: "Dropdown",
  setup(a) {
    const e = w(!1), t = b(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": e.value
    }));
    return (o, i) => (l(), n("div", {
      class: y(u(t))
    }, [
      s("div", {
        class: "cf-dropdown-toggle",
        onClick: i[0] || (i[0] = (d) => e.value = !e.value)
      }, [
        r(o.$slots, "toggle")
      ]),
      s("div", se, [
        r(o.$slots, "body")
      ]),
      s("div", {
        class: "cf-dropdown-backdrop",
        onClick: i[1] || (i[1] = (d) => e.value = !1)
      })
    ], 2));
  }
};
const oe = {
  key: 0,
  class: "cf-app-bar-link"
}, ae = { class: "cf-app-bar-link__label" }, ne = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), de = {
  key: 1,
  class: "cf-app-bar-link"
}, ie = { class: "cf-app-bar-link__label" }, Wt = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(a) {
    return (e, t) => a.dropdown ? (l(), n("div", oe, [
      L(le, null, {
        toggle: m(() => [
          s("div", ae, [
            r(e.$slots, "default"),
            ne
          ])
        ]),
        body: m(() => [
          r(e.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (l(), n("button", de, [
      s("div", ie, [
        r(e.$slots, "default")
      ])
    ]));
  }
};
const Yt = {
  __name: "AppBody",
  props: {
    wide: {
      type: Boolean,
      default: !1
    }
  },
  setup(a) {
    const e = a, t = b(() => ({
      "cf-app-body": !0,
      "cf-app-body--wide": e.wide
    }));
    return (o, i) => (l(), n("div", {
      class: y(u(t))
    }, [
      r(o.$slots, "default")
    ], 2));
  }
};
const es = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(a) {
    const e = a, t = b(() => ({
      "cf-banner": !0,
      [`cf-banner--${e.type}`]: e.type
    }));
    return (o, i) => (l(), n("div", {
      class: y(u(t))
    }, [
      r(o.$slots, "default")
    ], 2));
  }
}, P = {
  to: {
    type: String,
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: {
    type: Boolean,
    default: !1
  },
  wide: {
    type: Boolean,
    default: !1
  },
  color: {
    type: String,
    default: null
  },
  loading: {
    type: Boolean,
    default: !1
  },
  disabled: {
    type: Boolean,
    default: !1
  }
};
const re = ["type", "disabled"], ts = {
  __name: "FilledButton",
  props: P,
  setup(a) {
    const e = a, t = b(() => ({
      "cf-button": !0,
      "cf-button--large": e.large,
      "cf-button--wide": e.wide,
      "cf-button--loading": e.loading,
      "cf-button--disabled": e.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${e.color}`]: e.color
    }));
    return (o, i) => {
      const d = C("router-link");
      return o.to ? (l(), k(d, {
        key: 0,
        class: y(u(t)),
        to: o.to,
        inert: e.disabled
      }, {
        default: m(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), n("button", {
        key: 1,
        class: y(u(t)),
        type: e.type,
        disabled: e.disabled
      }, [
        r(o.$slots, "default")
      ], 10, re));
    };
  }
};
const ue = ["type", "disabled"], ss = {
  __name: "OutlinedButton",
  props: P,
  setup(a) {
    const e = a, t = b(() => ({
      "cf-button": !0,
      "cf-button--large": e.large,
      "cf-button--wide": e.wide,
      "cf-button--loading": e.loading,
      "cf-button--disabled": e.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${e.color}`]: e.color
    }));
    return (o, i) => {
      const d = C("router-link");
      return o.to ? (l(), k(d, {
        key: 0,
        class: y(u(t)),
        to: o.to,
        inert: e.disabled
      }, {
        default: m(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), n("button", {
        key: 1,
        class: y(u(t)),
        type: e.type,
        disabled: e.disabled
      }, [
        r(o.$slots, "default")
      ], 10, ue));
    };
  }
};
const ce = ["disabled"], ls = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(a) {
    const e = a;
    return (t, o) => {
      const i = C("router-link");
      return a.to ? (l(), k(i, {
        key: 0,
        class: "cf-text-button",
        to: a.to,
        inert: e.disabled
      }, {
        default: m(() => [
          r(t.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (l(), n("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: e.disabled
      }, [
        r(t.$slots, "default")
      ], 8, ce));
    };
  }
};
const _e = { class: "cf-choice" }, pe = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], fe = ["for"], ve = { key: 0 }, be = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Array],
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: String,
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = Math.random(), i = {
      name: A("choice-list-name", null),
      required: A("choice-list-required", null)
    }, d = b({
      get() {
        return t.modelValue;
      },
      set(c) {
        e("update:modelValue", c);
      }
    });
    return (c, f) => (l(), n("div", _e, [
      V(s("input", {
        "onUpdate:modelValue": f[0] || (f[0] = ($) => B(d) ? d.value = $ : null),
        type: t.type,
        id: u(o),
        name: i.name,
        value: t.value,
        "true-value": t.trueValue,
        "false-value": t.falseValue,
        required: i.required,
        disabled: t.disabled
      }, null, 8, pe), [
        [N, u(d)]
      ]),
      s("label", { for: u(o) }, p(t.label || t.value), 9, fe),
      t.helper ? (l(), n("small", ve, p(t.helper), 1)) : v("", !0)
    ]));
  }
};
const me = {
  key: 0,
  class: "cf-choice-list__label"
}, os = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = b(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": t.disabled
    })), i = b({
      get() {
        return t.modelValue;
      },
      set(d) {
        e("update:modelValue", d);
      }
    });
    return M("choice-list-name", Math.random()), M("choice-list-required", t.required), (d, c) => (l(), n("div", {
      class: y(u(o))
    }, [
      t.label ? (l(), n("div", me, p(t.label), 1)) : v("", !0),
      (l(!0), n(x, null, D(a.choices, (f) => (l(), k(be, {
        key: f.value || f,
        type: t.multiple ? "checkbox" : "radio",
        label: f.label || f.value || f,
        helper: f.helper,
        value: f.value || f,
        disabled: t.disabled,
        modelValue: u(i),
        "onUpdate:modelValue": c[0] || (c[0] = ($) => B(i) ? i.value = $ : null)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128))
    ], 2));
  }
};
const he = { class: "cf-field" }, ye = ["required", "disabled"], ge = {
  key: 0,
  value: null
}, $e = ["value"], ke = ["required", "disabled"], we = ["type", "placeholder", "list", "required", "disabled"], Se = { key: 3 }, Be = { key: 4 }, xe = {
  __name: "Field",
  props: {
    modelValue: [Number, String],
    type: String,
    label: String,
    placeholder: String,
    options: Array,
    list: String,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = b({
      get() {
        return t.modelValue;
      },
      set(i) {
        e("update:modelValue", i);
      }
    });
    return (i, d) => (l(), n("div", he, [
      t.type === "select" ? V((l(), n("select", {
        key: 0,
        class: "cf-field__input",
        "onUpdate:modelValue": d[0] || (d[0] = (c) => B(o) ? o.value = c : null),
        required: t.required,
        disabled: t.disabled
      }, [
        t.required ? v("", !0) : (l(), n("option", ge)),
        (l(!0), n(x, null, D(t.options, (c) => (l(), n("option", {
          key: c.value || c,
          value: c.value || c
        }, p(c.label || c), 9, $e))), 128))
      ], 8, ye)), [
        [O, u(o)]
      ]) : t.type === "textarea" ? V((l(), n("textarea", {
        key: 1,
        class: "cf-field__input",
        "onUpdate:modelValue": d[1] || (d[1] = (c) => B(o) ? o.value = c : null),
        required: t.required,
        disabled: t.disabled
      }, null, 8, ke)), [
        [K, u(o)]
      ]) : V((l(), n("input", {
        key: 2,
        class: "cf-field__input",
        "onUpdate:modelValue": d[2] || (d[2] = (c) => B(o) ? o.value = c : null),
        type: t.type,
        placeholder: t.placeholder,
        list: t.list,
        required: t.required,
        disabled: t.disabled
      }, null, 8, we)), [
        [N, u(o)]
      ]),
      t.label ? (l(), n("label", Se, p(t.label), 1)) : v("", !0),
      t.helper ? (l(), n("small", Be, p(t.helper), 1)) : v("", !0)
    ]));
  }
};
const Ce = { class: "cf-data-table-item" }, Ve = {
  key: 0,
  class: "cf-data-table-item__drawer"
}, De = { class: "cf-data-table-item__content" }, ze = ["data-label"], Le = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), qe = [
  Le
], Ae = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), Me = {
  __name: "DataTableItem",
  props: {
    data: Object,
    expandable: Boolean
  },
  setup(a) {
    const e = a, t = A("columns", []), o = w(!1);
    return (i, d) => {
      const c = C("router-link");
      return l(), n("div", Ce, [
        o.value ? (l(), n("div", Ve, [
          r(i.$slots, "default", {
            item: e.data
          })
        ])) : v("", !0),
        s("div", De, [
          (l(!0), n(x, null, D(u(t), (f) => (l(), n("div", {
            key: f.key,
            "data-label": f.label
          }, p(a.data[f.key]), 9, ze))), 128))
        ]),
        e.expandable ? (l(), n("button", {
          key: 1,
          class: "cf-data-table-item__toggle",
          onClick: d[0] || (d[0] = (f) => o.value = !o.value)
        }, qe)) : v("", !0),
        e.data.to ? (l(), k(c, {
          key: 2,
          class: "cf-data-table-item__toggle",
          to: e.data.to
        }, {
          default: m(() => [
            Ae
          ]),
          _: 1
        }, 8, ["to"])) : v("", !0),
        e.expandable && o.value ? (l(), n("div", {
          key: 3,
          class: "cf-data-table-item__backdrop",
          onClick: d[1] || (d[1] = (f) => o.value = !1)
        })) : v("", !0)
      ]);
    };
  }
};
const Ne = { class: "cf-data-table" }, Fe = { class: "cf-data-table__header" }, Ie = { class: "cf-data-table__header__content" }, Te = {
  key: 0,
  class: "cf-data-table__title"
}, Pe = {
  key: 1,
  class: "cf-data-table__description"
}, Ue = {
  key: 2,
  class: "cf-data-table__search"
}, Oe = {
  key: 3,
  class: "cf-data-table__actions"
}, Ke = {
  key: 0,
  class: "cf-data-table__header__slot"
}, je = { class: "cf-data-table__body__header" }, Ee = { class: "cf-data-table__body__items" }, Ze = {
  key: 0,
  class: "cf-data-table__footer"
}, Ge = { class: "cf-data-table__footer__pagination" }, Re = ["disabled"], He = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M11.022 14.503L4.518 8l6.504-6.504.707.707L5.932 8l5.797 5.796-.707.707z" })
], -1), Xe = [
  He
], Je = ["disabled"], Qe = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M4.99 14.503l-.707-.707L10.08 8 4.283 2.203l.707-.707L11.494 8 4.99 14.503z" })
], -1), We = [
  Qe
], Ye = { key: 0 }, as = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    expandable: Boolean,
    paginate: {
      type: Boolean,
      default: !0
    },
    searchKey: String,
    pluralTerm: {
      type: String,
      default: "items"
    },
    itemKey: String,
    pageSize: {
      type: [Number, String],
      default: 10
    },
    columns: {
      type: Array,
      default: []
    },
    data: {
      type: Array,
      default: []
    }
  },
  setup(a) {
    const e = a, t = j(), o = w(""), i = b(() => e.data.filter((_) => {
      if (o.value) {
        const S = _[e.searchKey].replaceAll(" ", "").toLowerCase(), g = o.value.replaceAll(" ", "").toLowerCase();
        return S.includes(g);
      } else
        return !0;
    })), d = w(1), c = b(() => Math.ceil(i.value.length / parseInt(e.pageSize))), f = b(() => {
      const _ = d.value < c.value ? d.value * e.pageSize : i.value.length;
      return {
        start: (d.value - 1) * e.pageSize + 1,
        end: _
      };
    }), $ = b(() => e.paginate ? i.value.slice(
      (d.value - 1) * parseInt(e.pageSize),
      d.value * parseInt(e.pageSize)
    ) : i.value), q = () => {
      d.value < c.value && d.value++;
    }, h = () => {
      d.value > 1 && d.value--;
    };
    return E(o, () => {
      d.value > 1 && (d.value = 1);
    }), M("columns", e.columns), (_, S) => (l(), n("div", Ne, [
      s("div", Fe, [
        s("div", Ie, [
          e.title ? (l(), n("div", Te, p(e.title), 1)) : v("", !0),
          e.description ? (l(), n("div", Pe, p(e.description), 1)) : v("", !0),
          e.searchKey ? (l(), n("div", Ue, [
            L(xe, {
              modelValue: o.value,
              "onUpdate:modelValue": S[0] || (S[0] = (g) => o.value = g),
              type: "text",
              label: "Search"
            }, null, 8, ["modelValue"])
          ])) : v("", !0),
          u(t).actions ? (l(), n("div", Oe, [
            r(_.$slots, "actions")
          ])) : v("", !0)
        ]),
        u(t).header ? (l(), n("div", Ke, [
          r(_.$slots, "header")
        ])) : v("", !0)
      ]),
      s("div", {
        class: "cf-data-table__body",
        style: Z(`--columns: ${e.columns.length}`)
      }, [
        s("div", je, [
          (l(!0), n(x, null, D(e.columns, (g) => (l(), n("div", {
            key: g.key
          }, p(g.label), 1))), 128))
        ]),
        s("div", Ee, [
          (l(!0), n(x, null, D(u($), (g) => (l(), k(Me, {
            key: g._id || g[e.itemKey],
            data: g,
            expandable: e.expandable
          }, {
            default: m((U) => [
              r(_.$slots, "item-drawer", {
                item: U.item
              })
            ]),
            _: 2
          }, 1032, ["data", "expandable"]))), 128))
        ])
      ], 4),
      e.paginate ? (l(), n("div", Ze, [
        s("div", Ge, [
          s("button", {
            disabled: d.value <= 1,
            onClick: h
          }, Xe, 8, Re),
          s("button", {
            disabled: d.value >= u(c),
            onClick: q
          }, We, 8, Je),
          u(i).length ? (l(), n("div", Ye, [
            s("b", null, p(`${u(f).start} to ${u(f).end}`), 1),
            F(" of "),
            s("b", null, p(u(i).length), 1)
          ])) : v("", !0)
        ])
      ])) : v("", !0)
    ]));
  }
};
const et = { class: "cf-sidebar-nav" }, tt = /* @__PURE__ */ s("hr", null, null, -1), st = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), lt = /* @__PURE__ */ s("span", null, "Collapse sidebar", -1), ot = [
  st,
  lt
], at = {
  __name: "Sidebar",
  setup(a) {
    const e = w(!1), t = b(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": e.value
    }));
    return (o, i) => (l(), n("aside", {
      class: y(u(t))
    }, [
      s("nav", et, [
        r(o.$slots, "default"),
        tt
      ]),
      s("button", {
        class: "cf-sidebar-toggle",
        onClick: i[0] || (i[0] = (d) => e.value = !e.value)
      }, ot)
    ], 2));
  }
};
const ns = {
  __name: "DefaultLayout",
  setup(a) {
    return I(() => {
      document.body.dataset.layout = "default";
    }), (e, t) => (l(), n(x, null, [
      L(te, null, {
        left: m(() => [
          r(e.$slots, "brand")
        ]),
        right: m(() => [
          r(e.$slots, "navigation")
        ]),
        _: 3
      }),
      L(at, null, {
        default: m(() => [
          r(e.$slots, "sidebar")
        ]),
        _: 3
      }),
      s("main", null, [
        r(e.$slots, "main")
      ])
    ], 64));
  }
};
const nt = { class: "cf-dialog-header" }, dt = { class: "cf-dialog__title" }, it = { key: 0 }, rt = { class: "cf-dialog-body" }, ut = { class: "cf-dialog-footer" }, ct = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), _t = [
  ct
], ds = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(a, { emit: e }) {
    const t = a, o = w(null);
    return I(() => o.value.showModal()), (i, d) => (l(), n("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: o
    }, [
      s("div", nt, [
        s("div", dt, p(t.title), 1),
        t.description ? (l(), n("div", it, p(t.description), 1)) : v("", !0)
      ]),
      s("div", rt, [
        r(i.$slots, "body")
      ]),
      s("div", ut, [
        r(i.$slots, "footer")
      ]),
      s("button", {
        class: "cf-dialog-close",
        onClick: d[0] || (d[0] = (c) => e("close"))
      }, _t)
    ], 512));
  }
};
const pt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, ft = { class: "material-symbols-outlined" }, vt = { class: "cf-dropdown-item__label" }, bt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, mt = { class: "material-symbols-outlined" }, ht = { class: "cf-dropdown-item__label" }, is = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(a) {
    const e = a, t = b(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": e.large
    }));
    return (o, i) => {
      const d = C("router-link");
      return a.to ? (l(), k(d, {
        key: 1,
        class: y(u(t)),
        to: a.to
      }, {
        default: m(() => [
          a.icon ? (l(), n("div", bt, [
            s("span", mt, p(a.icon), 1)
          ])) : v("", !0),
          s("div", ht, [
            r(o.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (l(), n("button", {
        key: 0,
        class: y(u(t))
      }, [
        a.icon ? (l(), n("div", pt, [
          s("span", ft, p(a.icon), 1)
        ])) : v("", !0),
        s("div", vt, [
          r(o.$slots, "default")
        ])
      ], 2));
    };
  }
};
const yt = { class: "cf-drop-zone" }, gt = ["onDrop"], $t = { class: "cf-drop-zone-box__label" }, kt = { class: "cf-drop-zone-box__action" }, wt = /* @__PURE__ */ s("span", null, "select from device", -1), St = ["required"], Bt = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, xt = {
  key: 1,
  class: "cf-drop-zone-list"
}, Ct = /* @__PURE__ */ s("div", { class: "cf-drop-zone-list__header" }, null, -1), Vt = { class: "cf-drop-zone-list__item" }, Dt = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ s("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), zt = [
  Dt
], rs = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(a, { emit: e }) {
    const t = a, o = w(null), i = b(() => !!(t.required && !t.modelValue)), d = b(() => {
      if (t.modelValue) {
        const _ = (t.modelValue.size / 1048576).toFixed(0), S = (_ / 1e3).toFixed(1);
        return _ < 100 ? `${_} MB` : `${S} GB`;
      } else
        return "0 MB";
    }), c = (h) => {
      const _ = h.target.files[0];
      $(_);
    }, f = (h) => {
      const _ = h.dataTransfer.files[0];
      $(_);
    }, $ = (h) => {
      const _ = parseInt(t.max) * 1048576;
      _ && _ < h.size ? (o.value.value = "", alert(`File cannot exceed ${t.max} MB`)) : (e("update:modelValue", h), e("add", h));
    }, q = () => {
      e("update:modelValue", null), e("cancel");
    };
    return (h, _) => (l(), n("div", yt, [
      a.modelValue ? (l(), n("div", xt, [
        Ct,
        s("div", Vt, [
          s("div", null, p(t.modelValue.name), 1),
          s("div", null, p(u(d)), 1),
          s("button", { onClick: q }, zt)
        ])
      ])) : (l(), n("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: z(f, ["prevent"]),
        onDragenter: _[0] || (_[0] = z(() => {
        }, ["prevent"])),
        onDragover: _[1] || (_[1] = z(() => {
        }, ["prevent"])),
        onDragleave: _[2] || (_[2] = z(() => {
        }, ["prevent"]))
      }, [
        s("div", $t, p(t.label), 1),
        s("label", kt, [
          F(" Drag and drop or "),
          wt,
          s("input", {
            type: "file",
            ref_key: "input",
            ref: o,
            required: u(i),
            onChange: c
          }, null, 40, St)
        ]),
        t.max ? (l(), n("div", Bt, " Files larger than " + p(t.max) + " MB cannot be uploaded ", 1)) : v("", !0)
      ], 40, gt))
    ]));
  }
};
const Lt = ["value", "max"], us = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(a) {
    const e = a;
    return (t, o) => (l(), n("progress", {
      class: "cf-progress",
      value: e.value,
      max: e.max
    }, p(a.value) + "% ", 9, Lt));
  }
};
const qt = { class: "cf-sidebar-link__icon" }, At = { class: "material-symbols-outlined" }, Mt = { class: "cf-sidebar-link__label" }, Nt = ["href"], Ft = { class: "cf-sidebar-link__icon" }, It = { class: "material-symbols-outlined" }, Tt = { class: "cf-sidebar-link__label" }, cs = {
  __name: "SidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(a) {
    const e = a;
    return (t, o) => {
      const i = C("router-link");
      return a.to ? (l(), k(i, {
        key: 0,
        class: "cf-sidebar-link",
        to: e.to
      }, {
        default: m(() => [
          s("div", qt, [
            s("span", At, p(a.icon), 1)
          ]),
          s("div", Mt, [
            r(t.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (l(), n("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: a.href
      }, [
        s("div", Ft, [
          s("span", It, p(a.icon), 1)
        ]),
        s("div", Tt, [
          r(t.$slots, "default")
        ])
      ], 8, Nt));
    };
  }
};
const Pt = {}, Ut = { class: "cf-spinner" }, Ot = /* @__PURE__ */ s("div", null, null, -1), Kt = /* @__PURE__ */ s("div", null, null, -1), jt = /* @__PURE__ */ s("div", null, null, -1), Et = /* @__PURE__ */ s("div", null, null, -1), Zt = [
  Ot,
  Kt,
  jt,
  Et
];
function Gt(a, e) {
  return l(), n("div", Ut, Zt);
}
const _s = /* @__PURE__ */ T(Pt, [["render", Gt]]);
const Rt = { class: "cf-switch" }, Ht = ["value", "true-value", "false-value", "disabled"], Xt = {
  key: 0,
  class: "cf-switch__label"
}, ps = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = b({
      get() {
        return t.modelValue;
      },
      set(i) {
        e("update:modelValue", i);
      }
    });
    return (i, d) => (l(), n("div", Rt, [
      V(s("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": d[0] || (d[0] = (c) => B(o) ? o.value = c : null),
        type: "checkbox",
        value: t.value,
        "true-value": t.trueValue,
        "false-value": t.falseValue,
        disabled: t.disabled
      }, null, 8, Ht), [
        [G, u(o)]
      ]),
      t.label ? (l(), n("div", Xt, p(t.label), 1)) : v("", !0)
    ]));
  }
};
export {
  Qt as CfActionCard,
  te as CfAppBar,
  Wt as CfAppBarLink,
  Yt as CfAppBody,
  es as CfBanner,
  be as CfChoice,
  os as CfChoiceList,
  as as CfDataTable,
  ns as CfDefaultLayout,
  ds as CfDialog,
  rs as CfDropZone,
  le as CfDropdown,
  is as CfDropdownItem,
  xe as CfField,
  ts as CfFilledButton,
  ss as CfOutlinedButton,
  us as CfProgress,
  at as CfSidebar,
  cs as CfSidebarLink,
  _s as CfSpinner,
  ps as CfSwitch,
  ls as CfTextButton
};
